
\section{Software and Computing}
Since Embedded Systems does a lot of programming, data wrangling, and
simulating, this section serves as a quick reference and guide to understanding
the workflow, and why we use the tools we use. Most of the software used is free
except for Simulink, which is a part of MATLAB. There is nothing remotely like
it, but it is such a good tool for creating systems and analyzing them, that
there is no choice but to use it. Most of the work you will do does not require
it though, so you do not have to stress about it. However, it is preferable that
you use a UNIX operating system to do a lot of this work, and most of you
probably have a Windows machine. Section \ref{UNIX} will go into detail about
why we use UNIX and how to use it if you have a Windows machine.

The two programming languages that Embedded Systems uses are C/C++ and Python.
The two were created for two different purposes, and in our case C/C++ is for
programming the ACS itself, and Python is used for data processing. Of course,
MATLAB is also good for data processing, and most of you have probably taken the
course already. However, it is not free and there is also a good chance many of
you do not have your own copy, which means you will be forced to use the
computers in the computer lab and not your own computer. This is the biggest
reason we prefer using open source, free software as much as possible, so you
can have access to the tools we use freely at no cost. Section \ref{C/C++} will
focus on setting up a C/C++ environment and how to work with C/C++, and Section
\ref{Python} will take you through the basics of Python and its use cases.



\subsection{UNIX} \label{UNIX}
UNIX is actually not an operating system itself, it is more like a guideline
that operating systems must comply with before they can be called a UNIX
operating system. Most operating system are actually UNIX, even Android and Mac
OS X, with the exception of Windows, which is its own thing entirely. The reason
we prefer using UNIX is that it is much easier to program on than Windows,
especially for C/C++. Programming on Windows is not necessarily \emph{bad}, but
only if you are programming \emph{for} Windows. Python is relatively easy to
install and run, however if you want to do some more generic C/C++ programming
like we do, you would need to install the compiler yourself, and it is not as
simple as it is with Python.

On UNIX machines, \emph{gcc}, a compiler that a large majority uses, is available
on all UNIX machines right off the bat (at least with popular Linux distros). So
is Python. You can just open a text editor, write some code, compile it, and it
will run with no fuss. The other benefit of using a UNIX system is how easy it
is to talk to other UNIX systems, like a Raspberry Pi which we use frequently.
If you know its IP address, you can send commands/files over the network with a
small terminal command. On Windows, you need to install another program to do
that as well. The CFD software we use, for the most part, only runs on Linux.
Lastly, it provides a common base for us to work as a team, without the need to
account for different operating systems when writing scripts, programs, etc.

\subsubsection{Linux}
Linux is, if you have not guessed by now, a UNIX operating system. It is a
little more complicated than that, however. Linux itself is in fact a
\emph{kernel}, not a full operating system, like Windows or Mac OS X. Usually
when you hear anyone talking about Linux they are usually talking about
distributions, or distros. A distro is what makes Linux an ``operating system''.
You can think of a kernel like a car engine; it is the ``core'' of the car that
runs everything. Distros add a frame, doors, seats, lights, etc. around the
engine to make it complete. This includes things like user interfaces, desktop
environments, package managers, there is a lot of stuff. It is the complete
``car'' that makes an operating system. This is also the reason there are so many
distros, since each one builds off of the one Linux kernel to create different
flavors of operating systems. However, they all use the same ``engine'', so the
workflow and the way things are done are mostly the same.

\paragraph{This is a ``Paragraph''}
If you are starting out and trying to decide which Linux distro to use, the best
one is most likely Ubuntu. It is the least fuss and has everything you will
need. If you also want to do some CFD work with OpenFOAM, Ubuntu is the easiest
distro to install it on. Most likely you will not want to completely wipe
Windows off your computer, but if you want to use the whole Ubuntu desktop from
your Windows machine, you can install a virtual machine on Windows, and install
Ubuntu on that virtual machine. There are tons of tutorials on how to do this
available online. If you have a Mac, you already have all the stuff you need, so
it is best to leave it alone unless you really want to tinker with Linux. It is
the same process on Mac as it is on Windows if you want to install a virtual
machine. However, if you have a Windows machine but do not want to install a
virtual machine, you can install something else called Windows Subsystem for
Linux.

\subsubsection{Windows Subsystem for Linux}
Windows Subsystem for Linux (WSL) allows you to install the Linux kernel itself
on Windows, and interact with it through the command line. This is really all
you need it for, and you have access to your Windows files as well. It can be
installed through the Windows store, and there are a few commands you have to
run through Powershell before it can work properly. Afterwards you will be able
to use it to compile C/C++ and run Python and Bash scripts.


\subsection{C/C++} \label{C/C++}
C and C++ are both low level programming languages. C was originally developed
to write system software in the 60s and 70s, C++ being an extension of C that
came into existence a decade later. C++ is similar to C in that the general
syntax is the same, but there are more features. C only has functions and
structs. C++ has classes, which is its defining feature. Classes are similar to
structs except they have the ability to contain \emph{methods} as well, which
are essentially functions that belong to that class and can manipulate its
properties. 

\subsubsection{Basics}


\subsubsection{Compiling}
\subsubsection{Examples}

\subsection{Python} \label{Python}
\subsubsection{Basics}
\subsubsection{Setup}

\subsection{OpenFOAM}


\subsection{\LaTeX}
